<?php
namespace FiloBlu\Rma\Plugin;
use Magento\Sales\Api\Data\OrderExtensionFactory;
use Magento\Sales\Api\Data\OrderInterface;
use Magento\Sales\Api\OrderRepositoryInterface;

class OrderGet
{

    /**
     * OrderGet constructor.
     * @param OrderExtensionFactory $orderExtensionFactory
     */
    public function __construct(OrderExtensionFactory $orderExtensionFactory) {
        $this->orderExtensionFactory = $orderExtensionFactory;
    }

    /**
     * @param OrderRepositoryInterface $subject
     * @param OrderInterface $order
     * @return OrderInterface
     */
    public function afterGet(
        OrderRepositoryInterface $subject,
        OrderInterface $order
    ) {
        $extensionAttributes = $order->getExtensionAttributes();
        if ($extensionAttributes && $extensionAttributes->getPaymentFeeAmount()) {
            return $order;
        }
        if($order->getPayment()->getMethod() == \FiloBlu\Rma\Model\Payment\ChangeSizePay::PAYMENT_CODE) {
            /** @var \Magento\Sales\Api\Data\OrderExtension $orderExtension */
            $orderExtension = $extensionAttributes ? $extensionAttributes : $this->orderExtensionFactory->create();
            $orderExtension->setPaymentFeeAmount(floatval($order->getMspCodAmount()) - floatval($order->getMspCodTaxAmount()));
            $orderExtension->setBasePaymentFeeAmount(floatval($order->getBaseMspCodAmount()) - floatval($order->getBaseMspCodTaxAmount()));
            $orderExtension->setPaymentTaxAmount(floatval($order->getMspCodTaxAmount()));
            $orderExtension->setBasePaymentTaxAmount(floatval($order->getBaseMspCodTaxAmount()));
            $order->setExtensionAttributes($orderExtension);
        }
        return $order;
    }
}